function callJSX(syncFile) {
    var response = {
        error: null,
        filePath: null,
        name: null,
        fileSize: null,
    }

    var doc = null;

    if (app.documents.length < 1) {
        response.error = 'no-document-open'
        return buildResponse(response, syncFile)
    }

    try {
        if (!app.activeDocument.saved) {
            app.activeDocument.save()
        }

        response.filePath = app.activeDocument.fullName.fsName.toString()
        response.name = app.activeDocument.name.toString()
        response.fileSize = File(app.activeDocument.fullName.fsName).length
        if (!response.fileSize) {
            throw error
        }

        return buildResponse(response, syncFile)
    } catch(e) {
        response.error = 'document-is-not-saved'
        return buildResponse(response, syncFile)
    }
};

function buildResponse (response, syncFile) {
    if (syncFile && response.filePath) {
        var avcdSyncFile = new File( Folder.temp + '/avocode-ps-sync.'+new Date().getTime()+'.avo')
        avcdSyncFile.open('w', undefined, undefined)
        avcdSyncFile.encoding = "UTF-8"
        avcdSyncFile.lineFeed = "Unix"

        var data = "{\"exportData\":{\"mode\":\"ps\",\"psdPath\":\"" + response.filePath.replace(/\\/g, "\\\\") + "\"}}"
        avcdSyncFile.writeln(data)
        avcdSyncFile.close()
        response.filePath = avcdSyncFile.fsName.toString()
    }
    var SEPARATOR = '@@#DK#@@'
    var res = response.filePath + SEPARATOR + response.error + SEPARATOR + response.name  + SEPARATOR + response.fileSize
    return res
}


function getHomePath () {
    var homeDir = new File('~/')
    var homeDirAbsolutePath = homeDir.fsName
    homeDir.close()

    return homeDirAbsolutePath
}
